#include <bits/stdc++.h>
using namespace std;
#define ll long long

ll max_ll(ll a, ll b) {
    return (a > b) ? a : b;
}
ll min_ll(ll a, ll b) {
    return (a > b) ? b : a;
}

int main() {
    ll n, k; cin >> n >> k;
    vector<ll> v(n); for (int i = 0; i < n; i++) cin >> v[i];
    vector<ll> pref(n + 1);
    pref[0] = 0;
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + v[i - 1];
    }
    vector<ll> pref_min(n + 1);
    pref_min[0] = 2e9;
    for (int i = 1; i <= n; i++) {
        pref_min[i] = min_ll(pref_min[i - 1], v[i - 1]);
    }
    vector<ll> suf_min(n + 1);
    suf_min[n] = 2e9;
    for (int i = n - 1; i >= 0; i--) {
        suf_min[i] = min_ll(suf_min[i + 1], v[i]);
    }
    ll ans = 0;
    for (int i = 0; i < k; i++) {
        ll sum_now = pref[i + n - k + 1] - pref[i];
        ll min_now = min_ll(pref_min[i], suf_min[i + n - k + 1]);
        ans = max_ll(ans, sum_now - min_now);
    }
    cout << ans << endl;
}